<script setup lang="ts">
import SelectOCEL from "@/components/SelectOCEL.vue";
import ClusterOCEL from "@/components/ClusterOCEL.vue";
import ClusteringResultsOCEL from "@/components/ClusteringResultsOCEL.vue";
import VisualizeOCEL from "@/components/VisualizeOCEL.vue";
import VisualizeSVG from "../components/VisualizeSVG.vue";
import type { API_File } from "@/types";
import { reactive, watch } from "vue";
import ROOT_URL from "@/../settings";

const state = reactive<{
  selected_file: API_File | null;
  current_clustering_id: string | null;
  selected_cluster_index: number | null;
  api_route_selected_cluster: string | null;
  original_ocel_graph_url: string | null;
}>({
  selected_file: null,
  current_clustering_id: null,
  selected_cluster_index: null,
  api_route_selected_cluster: null,
  original_ocel_graph_url: null,
});

function onNewResult(filename: string, clustering_id: string) {
  state.current_clustering_id = clustering_id;
  console.log(clustering_id);
}

watch(
  () => state.selected_cluster_index,
  () => {
    if (
      state.selected_cluster_index != null &&
      state.selected_file != null &&
      state.current_clustering_id != null
    )
      state.api_route_selected_cluster = `${ROOT_URL}/ocel-cluster/${state.selected_file.id}/clustering/${state.current_clustering_id}/clusters/${state.selected_cluster_index}/graph`;
  }
);
</script>

<template>
  <main>
    <div class="container">
      <SelectOCEL
        @filechange="
          (filename) => {
            state.selected_file = filename;
            state.original_ocel_graph_url =
              state.selected_file == null
                ? null
                : `${ROOT_URL}/ocel-cluster/${state.selected_file.id}/graph`;
          }
        "
      />
      <VisualizeOCEL
        v-if="state.original_ocel_graph_url != null"
        :api_route="state.original_ocel_graph_url"
      ></VisualizeOCEL>
      <ClusterOCEL
        v-if="state.selected_file != null"
        :ocel_file="state.selected_file"
        @newresult="onNewResult"
      />
      <VisualizeSVG
        v-if="
          state.selected_file != null && state.current_clustering_id != null
        "
        :heading="'Plot'"
        :api_route="`${ROOT_URL}/ocel-cluster/${state.selected_file.id}/clustering/${state.current_clustering_id}/evaluation/plot`"
      ></VisualizeSVG>
      <VisualizeSVG
        v-if="
          state.selected_file != null && state.current_clustering_id != null
        "
        :heading="'Scatterplot'"
        :api_route="`${ROOT_URL}/ocel-cluster/${state.selected_file.id}/clustering/${state.current_clustering_id}/evaluation/scatter`"
      ></VisualizeSVG>
      <ClusteringResultsOCEL
        v-if="
          state.current_clustering_id != null && state.selected_file != null
        "
        :ocel_file="state.selected_file.id"
        :clustering_id="state.current_clustering_id"
        v-model:selected_cluster_index="state.selected_cluster_index"
      />
      <VisualizeOCEL
        v-if="state.selected_cluster_index != null"
        :api_route="state.api_route_selected_cluster"
      ></VisualizeOCEL>
    </div>
  </main>
</template>
